]> gcc.gnu.org Git - gcc.git/blame - maintainer-scripts/gcc_release
gcc_release (build_sources): Create/update the LAST_UPDATED file in the source direct...
[gcc.git] / maintainer-scripts / gcc_release
CommitLineData
b4075f6b
JM
1#! /bin/sh
2
3########################################################################
4#
5# File: gcc_release
6# Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7# Date: 2001-05-25
8#
9# Contents:
10# Script to create a GCC release.
11#
b8f93352 12# Copyright (c) 2001, 2002 Free Software Foundation.
b4075f6b 13#
567bfee8 14# This file is part of GCC.
b4075f6b 15#
567bfee8 16# GCC is free software; you can redistribute it and/or modify
b4075f6b
JM
17# it under the terms of the GNU General Public License as published by
18# the Free Software Foundation; either version 2, or (at your option)
19# any later version.
20#
567bfee8 21# GCC is distributed in the hope that it will be useful,
b4075f6b
JM
22# but WITHOUT ANY WARRANTY; without even the implied warranty of
23# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24# GNU General Public License for more details.
25#
26# You should have received a copy of the GNU General Public License
567bfee8 27# along with GCC; see the file COPYING. If not, write to
b4075f6b
JM
28# the Free Software Foundation, 59 Temple Place - Suite 330,
29# Boston, MA 02111-1307, USA.
30#
31########################################################################
32
33########################################################################
34# Notes
35########################################################################
36
37# Here is an example usage of this script, to create a GCC 3.0.2
38# prerelease:
39#
40# gcc_release -r 3.0.2
41#
42# This script will automatically use the head of the release branch
43# to generate the release.
44
45########################################################################
46# Functions
47########################################################################
48
49# Issue the error message given by $1 and exit with a non-zero
50# exit code.
51
52error() {
53 echo "gcc_release: error: $1"
54 exit 1
55}
56
57# Issue the informational message given by $1.
58
59inform() {
60 echo "gcc_release: $1"
61}
62
63# Issue a usage message explaining how to use this script.
64
65usage() {
66cat <<EOF
1f9d6256
GP
67gcc_release -r release [-f] [further options]
68gcc_release -s name:cvsbranch [further options]
c627639b
GP
69
70Options:
71
72 -r release Version of the form X.Y or X.Y.Z.
1f9d6256 73 -s name:cvsbranch Create a snapshot, not a real release.
c627639b
GP
74
75 -d destination Local working directory where we will build the release
76 (default=${HOME}).
77 -f Create a final release (and update ChangeLogs,...).
78 -l Indicate that we are running on gcc.gnu.org.
79 -p previous-tarball Location of a previous tarball (to generate diff files).
80 -t tag Tag to mark the release in CVS.
81 -u username Username for upload operations.
b4075f6b
JM
82EOF
83 exit 1
84}
85
86# Change to the directory given by $1.
87
88changedir() {
89 cd $1 || \
90 error "Could not change directory to $1"
91}
92
93# Each of the arguments is a directory name, relative to the top
94# of the source tree. Return another name for that directory, relative
95# to the working directory.
96
97adjust_dirs() {
98 for x in $@; do
99 echo `basename ${SOURCE_DIRECTORY}`/$x
100 done
101}
102
103# Build the source tree that will be the basis for the release
104# in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
105
106build_sources() {
107 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108 if [ -r ${WORKING_DIRECTORY} ]; then
109 error "\`${WORKING_DIRECTORY}' already exists"
110 fi
111 # Create the WORKING_DIRECTORY.
112 mkdir "${WORKING_DIRECTORY}" \
113 || error "Could not create \`${WORKING_DIRECTORY}'"
114 changedir "${WORKING_DIRECTORY}"
115
116 # If this is a final release, make sure that the ChangeLogs
117 # and version strings are updated.
118 if [ ${FINAL} -ne 0 ]; then
119 inform "Updating ChangeLogs and version files"
120
121 ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
b69cd3cf 122 -r ${CVSBRANCH} gcc || \
b4075f6b
JM
123 error "Could not check out release sources"
124 for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
4494cdde
GP
125 # Update this ChangeLog file only if it does not yet contain the
126 # entry we are going to add. (This is a safety net for repeated
127 # runs of this script for the same release.)
128 if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then
129 cat - ${x} > ${x}.new <<EOF
b4075f6b
JM
130${LONG_DATE} Release Manager
131
4494cdde 132 * GCC ${RELEASE} released.
b4075f6b
JM
133
134EOF
4494cdde
GP
135 mv ${x}.new ${x} || \
136 error "Could not update ${x}"
137 (changedir `dirname ${x}` && \
138 ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139 error "Could not commit ${x}"
140 fi
b4075f6b
JM
141 done
142
b4f94ac1 143 # Update `gcc/version.c'.
b4075f6b
JM
144 for x in gcc/version.c; do
145 y=`basename ${x}`
146 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
7daaf8fa 147 sed -e 's|version_string\[\] = \".*\"|version_string\[\] = \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
b4075f6b
JM
148 mv ${y}.new ${y} && \
149 ${CVS} ci -m 'Update version' ${y}) || \
150 error "Could not update ${x}"
151 done
b4075f6b
JM
152
153 # Make sure we tag the sources for a final release.
154 TAG="gcc_`echo ${RELEASE} | tr . _`_release"
155
156 rm -rf ${SOURCE_DIRECTORY}
157 fi
158
159 # Tag the sources.
160 if [ -n "${TAG}" ]; then
6124d3bd 161 inform "Tagging sources as ${TAG}"
b69cd3cf 162 ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
6124d3bd 163 error "Could not tag sources"
ae7a5439
GP
164 EXPORTTAG="-r${TAG}"
165 EXPORTDATE=""
166 else
167 if [ ${CVSBRANCH} != "HEAD" ]; then
168 EXPORTTAG="-r${CVSBRANCH}"
169 else
170 # HEAD is the default branch, no need to specify it.
171 EXPORTTAG=""
172 fi
173 EXPORTDATE="-D`date -u +"%Y-%m-%d %H:%M"` UTC"
b4075f6b
JM
174 fi
175
176 # Export the current sources.
ae7a5439
GP
177 inform "Retrieving sources (cvs export ${EXPORTTAG} ${EXPORTDATE} gcc)"
178
179 if [ -z "${EXPORTTAG}" ]; then
180 ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
181 "${EXPORTDATE}" gcc || \
182 error "Could not retrieve sources"
183 elif [ -z "${EXPORTDATE}" ]; then
184 ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
185 "${EXPORTTAG}" gcc || \
186 error "Could not retrieve sources"
187 else
188 error "Cannot specify -r and -D at the same time"
189 fi
b4075f6b 190
4fdbb1de
GP
191 # Run gcc_update on them to set up the timestamps nicely, and (re)write
192 # the LAST_UPDATED file containing the CVS tag/date used.
b4075f6b
JM
193 changedir "gcc-${RELEASE}"
194 contrib/gcc_update --touch
4fdbb1de 195 echo "Obtained from CVS: ${EXPORTTAG} ${EXPORTDATE}" > LAST_UPDATED
b4075f6b
JM
196
197 # Obtain some documentation files from the wwwdocs module.
198 inform "Retrieving HTML documentation"
199 changedir "${WORKING_DIRECTORY}"
36067e59 200 for x in bugs faq; do
b4075f6b
JM
201 (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
202 cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
203 ${SOURCE_DIRECTORY}) || \
204 error "Could not retrieve ${x}.html"
205 done
206
207 inform "Generating plain-text documentation from HTML"
208 changedir "${SOURCE_DIRECTORY}"
209 for file in *.html; do
210 newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
211 (${ENV} TERM=vt100 lynx -dump $file \
212 | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
213 > $newfile) || \
36067e59 214 error "Could not generate text-only version of ${file}"
b4075f6b
JM
215 done
216
217 # For a prerelease or real release, we need to generate additional
218 # files not present in CVS.
219 changedir "${SOURCE_DIRECTORY}"
220 if [ $SNAPSHOT -ne 1 ]; then
221 # Generate the documentation.
222 inform "Building install docs"
223 SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
224 DESTDIR=${SOURCE_DIRECTORY}/INSTALL
225 export SOURCEDIR
226 export DESTDIR
227 ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
228
229 # Regenerate the NEWS file.
230 contrib/gennews > gcc/NEWS || \
231 error "Could not regenerate NEWS files"
232
233 # Now, we must build the compiler in order to create any generated
234 # files that are supposed to go in the source directory. This is
235 # also a good sanity check to make sure that the release builds
236 # on at least one platform.
237 inform "Building compiler"
238 OBJECT_DIRECTORY=../objdir
239 contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
240 error "Could not rebuild GCC"
241
242 # Regenerate the Fotran NEWS and BUGS files.
243 (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
244 error "Could not regenerate Fortran NEWS and BUGS files"
245 fi
246
247 # Move message catalogs to source directory.
248 mv ../objdir/gcc/po/*.gmo gcc/po/
249
250 # Create a `.brik' file to use for checking the validity of the
251 # release.
252 changedir "${SOURCE_DIRECTORY}"
253 BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
254 ((find . -type f | sort > $BRIK_FILE) && \
255 brik -Gb -f ${BRIK_FILE} > .brik && \
256 rm ${BRIK_FILE}) || \
257 error "Could not compute brik checksum"
258}
259
260# Buid a single tarfile. The first argument is the name of the name
261# of the tarfile to build, without any suffixes. They will be added
262# automatically. The rest of the arguments are the files or
263# directories to include.
264
265build_tarfile() {
266 # Get the name of the destination tar file.
44d952b3 267 TARFILE="$1.tar.bz2"
b4075f6b
JM
268 shift
269
270 # Build the tar file itself.
44d952b3 271 (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
b4075f6b
JM
272 error "Could not build tarfile"
273 FILE_LIST="${FILE_LIST} ${TARFILE}"
274}
275
276# Build the various tar files for the release.
277
278build_tarfiles() {
279 inform "Building tarfiles"
280
281 changedir "${WORKING_DIRECTORY}"
282
283 # The GNU Coding Standards specify that all files should
284 # world readable.
285 chmod -R a+r ${SOURCE_DIRECTORY}
286 # And that all directories have mode 777.
287 find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
288
289 # Build one huge tarfile for the entire distribution.
290 build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
291
292 # Now, build one for each of the languages.
dbff21c5 293 build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
b4075f6b
JM
294 build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
295 build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
296 build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
297 build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
298 build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
299
300 # The core is everything else.
301 EXCLUDES=""
07cdae91 302 for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
dbff21c5 303 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
b4075f6b
JM
304 EXCLUDES="${EXCLUDES} --exclude $x"
305 done
306 build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
307 `basename ${SOURCE_DIRECTORY}`
1c0d0c3e 308}
b4075f6b 309
44d952b3
GP
310# Build .gz files.
311build_gzip() {
b4075f6b 312 for f in ${FILE_LIST}; do
44d952b3
GP
313 target=${f%.bz2}.gz
314 (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
b4075f6b
JM
315 done
316}
317
318# Build diffs against an old release.
319build_diffs() {
e776237d 320 old_dir=${1%/*}
b4075f6b 321 old_file=${1##*/}
44d952b3 322 old_vers=${old_file%.tar.bz2}
b4075f6b
JM
323 old_vers=${old_vers#gcc-}
324 inform "Building diffs against version $old_vers"
0a528c61 325 for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
44d952b3
GP
326 old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
327 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
0a1c5051
GP
328 if [ ! -e $old_tar ]; then
329 inform "$old_tar not found; not generating diff file"
330 elif [ ! -e $new_tar ]; then
331 inform "$new_tar not found; not generating diff file"
332 else
b4075f6b 333 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
44d952b3 334 ${f}-${old_vers}-${RELEASE}.diff.bz2
b4075f6b
JM
335 fi
336 done
337}
338
339# Build an individual diff.
340build_diff() {
341 changedir "${WORKING_DIRECTORY}"
342 tmpdir=gccdiff.$$
343 mkdir $tmpdir || error "Could not create directory $tmpdir"
344 changedir $tmpdir
44d952b3
GP
345 (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
346 (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
347 ${DIFF} $2 $4 > ../${5%.bz2}
b4075f6b
JM
348 if [ $? -eq 2 ]; then
349 error "Trouble making diffs from $1 to $3"
350 fi
44d952b3 351 ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
b4075f6b
JM
352 changedir ..
353 rm -rf $tmpdir
354 FILE_LIST="${FILE_LIST} $5"
355}
356
357# Upload the files to the FTP server.
b4075f6b
JM
358upload_files() {
359 inform "Uploading files"
360
361 changedir "${WORKING_DIRECTORY}"
362
e776237d
JM
363 # Make sure the directory exists on the server.
364 if [ $LOCAL -eq 0 ]; then
8d4d9d19
GP
365 ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
366 mkdir -p "${FTP_PATH}/diffs"
1971aca7 367 UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
e776237d 368 else
8d4d9d19 369 mkdir -p "${FTP_PATH}/diffs" \
b4075f6b 370 || error "Could not create \`${FTP_PATH}'"
1971aca7 371 UPLOAD_PATH=${FTP_PATH}
b4075f6b
JM
372 fi
373
8d4d9d19 374 # Then copy files to their respective (sub)directories.
b4075f6b
JM
375 for x in gcc*.gz gcc*.bz2; do
376 if [ -e ${x} ]; then
377 # Make sure the file will be readable on the server.
378 chmod a+r ${x}
379 # Copy it.
8d4d9d19
GP
380 case ${x} in
381 *.diff.*)
382 SUBDIR="diffs/";
383 ;;
384 *)
385 SUBDIR="";
386 esac
387 ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
388 || error "Could not upload ${x}"
b4075f6b
JM
389 fi
390 done
391}
392
b348a598
GP
393# Announce a snapshot, both on the web and via mail.
394announce_snapshot() {
395 inform "Updating links and READMEs on the FTP server"
396
397 TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
398 cd ~ftp/pub/gcc/snapshots
1116457a
GP
399 sed -e "s%@DATE@%$DATE%g" \
400 -e "s%@LAST_DATE@%$LAST_DATE%g" \
c73aebc3 401 -e "s%@BRANCH@%${BRANCH}%g" \
1116457a 402 -e "s%@RELEASE@%${RELEASE}%g" \
b348a598 403 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
b99f39de 404 mv $$ ${RELEASE}/README
1116457a
GP
405 sed -e "s%@DATE@%$DATE%g" \
406 -e "s%@LAST_DATE@%$LAST_DATE%g" \
c73aebc3 407 -e "s%@BRANCH@%${BRANCH}%g" \
1116457a 408 -e "s%@RELEASE@%${RELEASE}%g" \
b348a598 409 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
b99f39de 410 mv $$ ${RELEASE}/index.html
b348a598 411
c73aebc3
GP
412 touch LATEST-IS-${BRANCH}-${DATE}
413 rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
b348a598
GP
414
415 inform "Sending mail"
416
417 export QMAILHOST=gcc.gnu.org
b99f39de 418 mail -s "gcc-ss-${RELEASE} is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/${RELEASE}/README
b348a598
GP
419}
420
b4075f6b
JM
421########################################################################
422# Initialization
423########################################################################
424
425# Today's date.
426DATE=`date "+%Y%m%d"`
427LONG_DATE=`date "+%Y-%m-%d"`
428
429# The CVS server containing the GCC repository.
430CVS_SERVER="gcc.gnu.org"
431# The path to the repository on that server.
432CVS_REPOSITORY="/cvs/gcc"
433# The CVS protocol to use.
434CVS_PROTOCOL="ext"
435# The username to use when connecting to the server.
436CVS_USERNAME="${USER}"
437
b8f93352
MM
438# The machine to which files will be uploaded.
439GCC_HOSTNAME="gcc.gnu.org"
440# The name of the account on the machine to which files are uploaded.
441GCC_USERNAME="gccadmin"
442# The directory in which the files will be placed.
443FTP_PATH="~ftp/pub/gcc"
b4075f6b
JM
444
445# The major number for the release. For release `3.0.2' this would be
446# `3'
447RELEASE_MAJOR=""
448# The minor number for the release. For release `3.0.2' this would be
449# `0'.
450RELEASE_MINOR=""
451# The revision number for the release. For release `3.0.2' this would
452# be `2'.
453RELEASE_REVISION=""
454# The complete name of the release.
455RELEASE=""
456
b69cd3cf
GP
457# The name of the branch from which the release should be made, in a
458# user-friendly form.
b4075f6b
JM
459BRANCH=""
460
b69cd3cf
GP
461# The name of the branch from which the release should be made, as used
462# for our version control system.
463CVSBRANCH=""
464
b4075f6b
JM
465# The tag to apply to the sources used for the release.
466TAG=""
467
468# The old tarballs from which to generate diffs.
469OLD_TARS=""
470
471# The directory that will be used to construct the release. The
472# release itself will be placed in a subdirectory of this diretory.
473DESTINATION=${HOME}
474# The subdirectory.
475WORKING_DIRECTORY=""
476# The directory that will contain the GCC sources.
477SOURCE_DIRECTORY=""
478
479# The directories that should be part of the various language-specific
480# tar files. These are all relative to the top of the source tree.
dbff21c5 481ADA_DIRS="gcc/ada"
b4075f6b
JM
482CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
483FORTRAN_DIRS="gcc/f libf2c"
484JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
485OBJECTIVEC_DIRS="gcc/objc libobjc"
486TESTSUITE_DIRS="gcc/testsuite"
487
488# Non-zero if this is the final release, rather than a prerelease.
489FINAL=0
490
491# Non-zero if we are building a snapshot, and don't build gcc or
492# include generated files.
493SNAPSHOT=0
494
495# Non-zero if we are running locally on gcc.gnu.org, and use local CVS
496# and copy directly to the FTP directory.
497LOCAL=0
498
499# Major operation modes.
44d952b3 500MODE_GZIP=0
b8f93352 501MODE_DIFFS=0
b4075f6b
JM
502MODE_SOURCES=0
503MODE_TARFILES=0
504MODE_UPLOAD=0
505
44d952b3 506# List of archive files generated; used to create .gz files from .bz2.
b4075f6b
JM
507FILE_LIST=""
508
509# Programs we use.
510
511BZIP2="${BZIP2:-bzip2}"
512CVS="${CVS:-cvs -f -Q -z9}"
513DIFF="${DIFF:-diff -Nrc3pad}"
514ENV="${ENV:-env}"
515GZIP="${GZIP:-gzip --best}"
516SCP="${SCP:-scp -p}"
b8f93352 517SSH="${SSH:-ssh}"
b4075f6b
JM
518TAR="${TAR:-tar}"
519
520########################################################################
521# Command Line Processing
522########################################################################
523
524# Parse the options.
1f9d6256 525while getopts "d:fr:u:t:p:s:l" ARG; do
b4075f6b
JM
526 case $ARG in
527 d) DESTINATION="${OPTARG}";;
528 r) RELEASE="${OPTARG}";;
529 t) TAG="${OPTARG}";;
530 u) CVS_USERNAME="${OPTARG}";;
531 f) FINAL=1;;
1f9d6256
GP
532 s) SNAPSHOT=1
533 BRANCH=${OPTARG%:*}
534 CVSBRANCH=${OPTARG#*:}
535 ;;
b4075f6b
JM
536 l) LOCAL=1
537 SCP=cp
538 FTP_PATH=~ftp/pub/gcc
f83fd9ae 539 PATH=~:/usr/local/bin:$PATH;;
e776237d
JM
540 p) OLD_TARS="${OLD_TARS} ${OPTARG}"
541 if [ -d ${OPTARG} ]; then
542 error "-p argument must name a tarball"
543 fi;;
b4075f6b
JM
544 \?) usage;;
545 esac
546done
547shift `expr ${OPTIND} - 1`
548
2cd5026f
GP
549# Handle the major modes.
550while [ $# -ne 0 ]; do
551 case $1 in
552 diffs) MODE_DIFFS=1;;
553 gzip) MODE_GZIP=1;;
554 sources) MODE_SOURCES=1;;
555 tarfiles) MODE_TARFILES=1;;
556 upload) MODE_UPLOAD=1;;
557 all) MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
558 if [ $SNAPSHOT -ne 1 ]; then
559 # Only for releases and pre-releases.
560 MODE_GZIP=1;
561 fi
562 ;;
563 *) error "Unknown mode $1";;
564 esac
565 shift
566done
567
b4075f6b 568# Perform consistency checking.
b47a72ea 569if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
b4075f6b
JM
570 error "No username specified"
571fi
572
573if [ ! -d ${DESTINATION} ]; then
574 error "\`${DESTINATION}' is not a directory"
575fi
576
577if [ $SNAPSHOT -eq 0 ]; then
578 if [ -z ${RELEASE} ]; then
579 error "No release number specified"
580 fi
581
582 # Compute the major and minor release numbers.
583 RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
584 RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
585 RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
586
587 if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
588 error "Release number \`${RELEASE}' is invalid"
589 fi
590
591 # Compute the full name of the release.
592 if [ -z "${RELEASE_REVISION}" ]; then
593 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
594 else
595 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
596 fi
597
598 # Compute the name of the branch, which is based solely on the major
599 # and minor release numbers.
b69cd3cf 600 CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
b4075f6b
JM
601
602 # If this is not a final release, set various parameters acordingly.
603 if [ ${FINAL} -ne 1 ]; then
604 RELEASE="${RELEASE}-${DATE}"
7daaf8fa 605 FTP_PATH="${FTP_PATH}/prerelease-${RELEASE}/"
b4075f6b 606 else
b8f93352 607 FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
b4075f6b
JM
608 fi
609else
b99f39de
GP
610 RELEASE=${BRANCH}-${DATE}
611 FTP_PATH="${FTP_PATH}/snapshots/${RELEASE}"
1f9d6256
GP
612 if [ ${CVSBRANCH} != "HEAD" ]; then
613 TAG=gcc-ss-`echo ${RELEASE} | tr '.' '_'`
614 fi
b4075f6b
JM
615
616 # Building locally on gcc.gnu.org, we know what the last snapshot date
617 # was.
6124d3bd 618 if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ]; then
b69cd3cf 619 LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
c73aebc3 620 LAST_DIR=~ftp/pub/gcc/snapshots/${BRANCH}-${LAST_DATE}
b99f39de 621 OLD_TARS=${LAST_DIR}/gcc-${BRANCH}-${LAST_DATE}.tar.bz2
b4075f6b
JM
622 fi
623fi
624
625# Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
626WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
627SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
628
629# Recompute the names of all the language-specific directories,
630# relative to the WORKING_DIRECTORY.
dbff21c5 631ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
b4075f6b
JM
632CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
633FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
634JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
635OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
636TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
637
638# Set up CVSROOT.
639if [ $LOCAL -eq 0 ]; then
640 CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
641 CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
642else
643 CVSROOT="${CVS_REPOSITORY}"
644fi
645export CVSROOT
646
647########################################################################
648# Main Program
649########################################################################
650
1f1760d3
KC
651# Set the timezone to UTC
652TZ="UTC0"
653export TZ
654
b4075f6b
JM
655# Build the source directory.
656
657if [ $MODE_SOURCES -ne 0 ]; then
658 build_sources
659fi
660
661# Build the tar files.
662
663if [ $MODE_TARFILES -ne 0 ]; then
664 build_tarfiles
665fi
666
b8f93352
MM
667# Build diffs
668
669if [ $MODE_DIFFS -ne 0 ]; then
670 # Possibly build diffs.
671 if [ -n "$OLD_TARS" ]; then
672 for old_tar in $OLD_TARS; do
673 build_diffs $old_tar
674 done
675 fi
676fi
677
44d952b3
GP
678# Build gzip files
679if [ $MODE_GZIP -ne 0 ]; then
680 build_gzip
1c0d0c3e
JM
681fi
682
b4075f6b
JM
683# Upload them to the FTP server.
684
685if [ $MODE_UPLOAD -ne 0 ]; then
686 upload_files
687
688 # For snapshots, make some further updates.
689 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
b348a598 690 announce_snapshot
b4075f6b
JM
691
692 # Update snapshot date file.
693 changedir ~
b69cd3cf 694 echo $DATE > .snapshot_date-${BRANCH}
b4075f6b 695
b4075f6b
JM
696 # Remove working directory
697 rm -rf ${WORKING_DIRECTORY}
698 fi
699fi
This page took 0.248705 seconds and 5 git commands to generate.